var stalkSettings = function() {
    var B = ["background_color", "text_color", "link_color", "sidebar_fill_color", "sidebar_border_color"];
    var A = {
        updateUrl: function(C) {
            $("#username_url").html(C)
        },
        checkNameAvailability: function() {
            $.ajax({
                type: "GET",
                url: "/users/username_available",
                data: {
                    username: $("#user_screen_name").val()
                },
                dataType: "json",
                success: function(D) {
                    var E = D.msg;
                    var C = D.valid ? "green": "red";
                    $("#username_msg").html(E).css("color", C);
                    $("#username_url").css("color", C)
                },
                complete: function() {
                    $("#avail_check_indicator").fadeOut("medium",
                    function() {
                        $("#username_msg").fadeIn("medium")
                    });
                    clearTimeout(_tmp.checkNameAvailabilityTimer)
                }
            })
        },
        screenNameKeyUp: function() {
            jQuery("#user_screen_name").keyup(function(C) {
                var D = jQuery("#user_screen_name");
                if (D.val() != "") {
                    if (jQuery.inArray(C.keyCode, [16, 17, 18, 20, 27, 33, 34, 35, 37, 38, 39, 40, 144]) == -1) {
                        clearTimeout(_tmp.checkNameAvailabilityTimer);
                        jQuery("#username_url").html(D.val());
                        if (jQuery("#avail_check_indicator").css("display") == "none") {
                            jQuery("#username_msg").fadeOut("medium",
                            function() {
                                jQuery("#avail_check_indicator").fadeIn("medium")
                            })
                        }
                        _tmp.checkNameAvailabilityTimer = setTimeout("stalkSettings.checkNameAvailability()", 2000)
                    }
                }
            })
        },
        setTZ: function() {
            var C = $("#time_zone_select_row");
            $("#user_time_zone").children("option").each(function(D, E) {
                var F = $(E)[0];
                if (F.text.match(new RegExp("..." + ((new Date().getTimezoneOffset() / 60) * ( - 1)).toString().replace(/(.)([0-9])$/, "$10$2")))) {
                    $("#user_time_zone").attr("selectedIndex", F.index - 1);
                    F.selectedIndex = F.index;
                    return false
                }
            })
        },
        updateColors: function() {
            var E = $("#custom_background_color").val();
            var D = $("#custom_sidebar_color").val();
            var G = $("#custom_text_color").val();
            var F = $("#custom_link_color").val();
            var C = $("#custom_sidebar_border_color").val();
            $("body").css({
                "background-color": E,
                color: G
            });
            $("#side_base").css({
                "background-color": D,
                "border-color": C
            });
            $(".stats td+td").css("border-color", C);
            $("#side div.stats").css("border-color", C);
            $("#side div.section-header h3.faq-header").css("border-color", C);
            $("#side a").css("color", F);
            $("#design_customization a").css("color", F);
            $("#navigation a").css("color", F);
            $("#footer a").css("color", F);
            $(".top-navigation a").css("color", F);
            if ($("#backgrounds").css("display") != "none") {
                $("#current_tab").val("backgrounds")
            } else {
                if ($("#colors").css("display") != "none") {
                    $("#current_tab").val("colors")
                } else {
                    $("#current_tab").val("none")
                }
            }
        },
        setBackgroundImage: function(C, D) {
            if ((D === true) || (D === false)) {
                D = D
            } else {
                if ($("#tile_background:checked").val()) {
                    D = true
                } else {
                    D = false
                }
            }
            $("#custom_background").val(C == "none" ? "false": "true");
            $("body").css({
                "background-image": C == "none" ? "none": "url('" + C + "')",
                "background-repeat": D ? "repeat": "no-repeat",
                "background-attachment": D ? "scroll": "fixed"
            });
            $("#custom_background").val(C)
        },
        setTheme: function(D) {
            _tmp.hasCustomBackgroundImage = false;
            var C = themes[D];
            $("#tile_background").attr("checked", C.tiled);
            $("#current_background span").css("backgroundImage", "url('" + C.swatch + "')");
            $.each(B,
            function() {
                $("#custom_" + this).val(C[this]).css("background-color", C[this])
            });
            $("#themes").attr("class", "theme" + D);
            _tmp.currentImage = C.image;
            stalkSettings.setBackgroundImage(C.image, C.tiled);
            if (C.image != "none") {
                $("#current_background").addClass("active")
            } else {
                $("#no_background").addClass("active")
            }
            $("#custom_default").val(true);
            $("#custom_theme").val(D)
        },
        isDefaultDesign: function() {
            var D = themes[$("#custom_theme").val()];
            if ($("#custom_background").val() == "false" || $("#tile_background").attr("checked") != D.tiled || ($("#file").val() || _tmp.hasCustomBackgroundImage)) {
                return false
            }
            var C = true;
            $.each(B,
            function() {
                if ($("#custom_" + this).val() != D[this]) {
                    C = false
                }
            });
            if (!C) {
                return false
            }
            return true
        },
        validateDefaultDesign: function() {
            $("#custom_default").val(stalkSettings.isDefaultDesign())
        },
        synchColors: function(D) {
            var C = stalkSettings.colorPicker.linked;
            if (C && C.value && C.value != stalkSettings.colorPicker.color) {
                C.value = stalkSettings.colorPicker.color;
                $(C).css({
                    "background-color": C.value,
                    color: stalkSettings.colorPicker.hsl[2] > 0.5 ? "#000": "#fff"
                });
                stalkSettings.updateColors()
            }
        },
        initProfileDesign: function() {
            $("#title_picker a").click(function() {
                $("#colors").toggle();
                $("#backgrounds").hide();
                $("#title_background").removeClass("active");
                if ($("#colors").css("display") == "none") {
                    $("#title_picker").removeClass("active");
                    $("#title_background").removeClass("inactive")
                } else {
                    $("#title_picker").addClass("active");
                    $("#title_background").addClass("inactive")
                }
                if ($("#custom_default").val()) {
                    $("#custom_default").val(false)
                }
                return false
            });
            $("#title_background a").click(function() {
                $("#backgrounds").toggle();
                $("#colors").hide();
                $("#title_picker").removeClass("active");
                if ($("#backgrounds").css("display") == "none") {
                    $("#title_background").removeClass("active");
                    $("#title_picker").removeClass("inactive")
                } else {
                    $("#title_background").addClass("active");
                    $("#title_picker").addClass("inactive")
                }
                return false
            });
            $("#themes a").click(function() {
                var E = $(this).attr("id");
                stalkSettings.setTheme(E.substring(5));
                return false
            });
            $("#backgrounds a").click(function() {
                $("#backgrounds a").removeClass("active");
                $(this).addClass("active");
                var E = $(this).attr("id");
                if (E == "current_background") {
                    stalkSettings.setBackgroundImage(_tmp.currentImage)
                } else {
                    if (E == "no_background") {
                        stalkSettings.setBackgroundImage("none")
                    }
                }
                return false
            });
            $("#tile_background").click(function() {
                var E = $("#tile_background:checked").val();
                $("body").css({
                    "background-repeat": E ? "repeat": "no-repeat",
                    "background-attachment": E ? "scroll": "fixed"
                });
                $("#custom_background").val("true")
            });
            stalkSettings.colorPicker = $.farbtastic("#picker", stalkSettings.synchColors);
            $("#picker").click(function() {
                $(".colorwell-selected").focus()
            });
            var D;
            var C = (function() {
                var E = [8, 9, 13, 16, 17, 18, 37, 38, 39, 40, 45, 46, 86, 88, 90];
                for (var F = 48; F <= 57; F++) {
                    E.push(F)
                }
                for (var F = 65; F <= 70; F++) {
                    E.push(F)
                }
                for (var F = 96; F <= 105; F++) {
                    E.push(F)
                }
                return E
            })();
            $(".colorwell").each(stalkSettings.synchColors).focus(function() {
                if (D) {
                    $(D).removeClass("colorwell-selected")
                }
                stalkSettings.colorPicker.linked = this;
                stalkSettings.colorPicker.setColor(this.value);
                $("#picker").show();
                $(D = this).addClass("colorwell-selected")
            }).blur(function() {
                var E = $(E);
                E.val(E.val().toUpperCase())
            }).keydown(function(E) {
                if ($.inArray(E.keyCode, C) != -1) {
                    if ($.inArray(E.keyCode, [86, 88, 90]) != -1) {
                        return (E.ctrlKey || E.metaKey)
                    } else {
                        if (($.inArray(E.keyCode, [8, 46]) != -1) || ((E.keyCode == 88) && E.shiftKey)) {
                            return ($(this).val() != "#")
                        } else {
                            if (E.shiftKey) {
                                return ($.inArray(E.keyCode, [65, 66, 67, 68, 69, 70]) != -1)
                            }
                        }
                    }
                    return true
                }
                return false
            }).keyup(function(E) {
                if ($(this).val().indexOf("#") != 0) {
                    $(this).val("#" + $(this).val())
                }
                stalkSettings.colorPicker.setColor(this.value);
                var F = $(this).val();
                if (!document.all || (F.length == 7 || F.length == 4)) {
                    $(this).css({
                        "background-color": $(this).val(),
                        color: stalkSettings.colorPicker.hsl[2] > 0.5 ? "#000000": "#ffffff"
                    });
                    stalkSettings.updateColors()
                }
            });
            $("#design_customization form a").click(stalkSettings.updateColors)
        }
    };
    return A
} ();